/* $Id: parser.mly,v 1.1.1.1.2.4 2013/09/27 09:20:58 dmasse Exp $ */

/** Parsing */

%{ (* parser generated by ocamlyacc from file parser.mly *)

open Syntax

%} /* declarations */

%token Var_Token Init_Token Loop_Token Semicolon_Token Comma_Token Split_Token
%token <string> Double_Token Integer_Token Identifier_Token
%token Apostrophe_Token Equal_Token GreatEq_Token LessEq_Token Less_Token Great_Token LeftPar_Token
%token RightPar_Token LeftBra_Token RightBra_Token
%token Plus_Token Minus_Token Times_Token Div_Token
%token Eof_Token
%left Plus_Token Minus_Token
%left Times_Token Div_Token


%start n_Entry /* grammar axiom non terminal */
%type <Syntax.prog> n_Entry 

%% /* grammar rules */

/* entry */
n_Entry:
	n_Decls n_Init n_Split n_Loop Eof_Token { $2, $3, $4 }

n_Decls:
	Var_Token n_LVars Semicolon_Token { Syntax.declare_variables $2 }

n_LVars:
	  Identifier_Token	{ [$1] }
	| Identifier_Token Comma_Token n_LVars
				{ $1::$3 }

n_Init:
	Init_Token n_LConsts	{ Syntax.check_init $2 }
      |				{ [] }

n_Split:
	Split_Token n_LConsts	{ Syntax.check_trans $2 }
      |				{ [] }

n_LConsts:
				{ [] }
	| n_Const Semicolon_Token n_LConsts	{ $1::$3 }

n_Const:
	 n_Expr Equal_Token n_Expr	{ (Syntax.minus_expr $1 $3),EQ }
       | n_Expr LessEq_Token n_Expr	{ (Syntax.minus_expr $1 $3),LESSEQ }
       | n_Expr GreatEq_Token n_Expr	{ (Syntax.minus_expr $3 $1),LESSEQ }
       | n_Expr Less_Token n_Expr	{ (Syntax.minus_expr $1 $3),LESS }
       | n_Expr Great_Token n_Expr	{ (Syntax.minus_expr $3 $1),LESS }

n_Expr:
 	 LeftPar_Token n_Expr RightPar_Token	{ $2 }
       | Identifier_Token Apostrophe_Token { Syntax.expr_of_var $1 true }
       | Identifier_Token 		   { Syntax.expr_of_var $1 false }
       | Minus_Token n_Expr		   { Syntax.uminus_expr $2 }
       | n_Expr Plus_Token n_Expr	   { Syntax.plus_expr $1 $3 }
       | n_Expr Minus_Token n_Expr	   { Syntax.minus_expr $1 $3 }
       | n_Num				   { Syntax.cst_expr $1 }
       | n_Num Times_Token n_Expr	   { Syntax.prod_expr $1 $3 }
       | n_Expr Div_Token n_Num	     	   { Syntax.div_expr $1 $3 }

n_Num:
         Double_Token			   { Syntax.double_expr $1 }
       | Integer_Token			   { Syntax.integer_expr $1 }

n_Loop:
	 Loop_Token n_Transitions	   { $2 }

n_Transitions:
	 				   { [] }
	| n_Transition n_Transitions	   { $1@$2 }

n_Transition:
	LeftBra_Token n_LConsts n_Transitions RightBra_Token
					{ let nl = Syntax.check_trans $2 in
					  Syntax.distribute_trans nl $3 }
